package x64

import "git.akyoto.dev/cli/q/src/cpu"

const (
	RAX cpu.Register = iota
	RCX
	RDX
	RBX
	RSP
	RBP
	RSI
	RDI
	R8
	R9
	R10
	R11
	R12
	R13
	R14
	R15
)

var (
	AllRegisters           = []cpu.Register{RAX, RCX, RDX, RBX, RSP, RBP, RSI, RDI, R8, R9, R10, R11, R12, R13, R14, R15}
	SyscallInputRegisters  = []cpu.Register{RAX, RDI, RSI, RDX, R10, R8, R9}
	SyscallOutputRegisters = []cpu.Register{RAX, RCX, R11}
	GeneralRegisters       = []cpu.Register{RCX, RBX, R11, R12, R13, R14, R15, RBP}
	InputRegisters         = SyscallInputRegisters
	OutputRegisters        = SyscallInputRegisters
	WindowsInputRegisters  = []cpu.Register{RCX, RDX, R8, R9}
	WindowsOutputRegisters = []cpu.Register{RAX}
)
